﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using HeuristicLab.Common;
using HeuristicLab.Data;

namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
  public class UniformalDistribution : RandomDistribution {

    public double Start {
      get {
        return start;
      }
    }
    public double End {
      get {
        return end;
      }
    }

    public UniformalDistribution(IntRange range) : base(range.Start, range.End) { }
    public UniformalDistribution(double start, double end) : base(start, end) { }

    #region cloning
    protected UniformalDistribution(UniformalDistribution original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new UniformalDistribution(this, cloner);
    }
    #endregion

    public override Double Next() {
      return rand.NextDouble() * (end - start) + start;
    }
  }
}
